OSDN Git Service

contrib:
[pf3gnuchains/gcc-fork.git] / contrib / gcc_update
1 #! /bin/sh
2 #
3 # Update a local Subversion, Git or Mercurial tree from the GCC
4 # repository, with an emphasis on treating generated files correctly, so
5 # that autoconf, gperf et al are not required for the ``end'' user.
6 #
7 # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009, 2010,
8 # 2011 Free Software Foundation
9 # Originally by Gerald Pfeifer <pfeifer@dbai.tuwien.ac.at>, August 1998.
10 #
11 # This script is Free Software, and it can be copied, distributed and
12 # modified as defined in the GNU General Public License.  A copy of
13 # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
14 #
15 #
16 # By default all command-line options are passed to `svn update` or `hg/git
17 # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
18 # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
19 # are omitted.
20 #
21 # If the first parameter reads --patch, the second parameter is considered
22 # a patch file.
23 #
24 # If the first parameter is --touch, no svn operation will be performed,
25 # only generated files that appear to be out of date in the local tree
26 # will be touched.
27 #
28 # If the first parameter is --list, a list of the generated files and
29 # their dependencies will be printed; --help prints this message.
30 #
31 # If the first parameter is --silent, this script prints nothing other
32 # than error messages; the second parameter is then interpreted as above.
33 #
34 # Examples:
35 #
36 # contrib/gcc_update -r 8712
37 # contrib/gcc_update --patch some-patch
38 # contrib/gcc_update --touch
39 # contrib/gcc_update --list
40
41
42 # Default options used when updating (none).
43 UPDATE_OPTIONS=""
44
45 # Set the locale to C to make this script work for users with foreign
46 # locale like e.g. French UTF-8.
47 LANG=C
48 LC_ALL=C
49 export LANG LC_ALL
50
51 ######## Anything below shouldn't be changed by regular users.
52
53 # Arrange for the value of $0 to be available for functions
54 self=$0
55
56 # This function prints its arguments to standard output unless
57 # "silent" is set.
58 unset silent
59 chat () {
60     if [ -z "$silent" ]; then
61         echo "$@"
62     fi
63 }
64
65 # This function prints a list of all generated files, along with their
66 # dependencies.  Note that only one target is supported per line: the
67 # colon is stripped from the output.
68 files_and_dependencies () {
69     sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
70 # fixincludes
71 fixincludes/configure: fixincludes/configure.ac fixincludes/aclocal.m4
72 fixincludes/config.h.in: fixincludes/configure.ac fixincludes/aclocal.m4
73 # intl library
74 intl/plural.c: intl/plural.y
75 intl/configure: intl/configure.ac intl/aclocal.m4
76 intl/config.h.in: intl/configure.ac intl/aclocal.m4
77 # Now, proceed to gcc automatically generated files
78 gcc/configure: gcc/configure.ac
79 gcc/cstamp-h.in: gcc/configure.ac
80 gcc/config.in: gcc/cstamp-h.in
81 gcc/fixinc/fixincl.x: gcc/fixinc/fixincl.tpl gcc/fixinc/inclhack.def
82 gcc/config/arm/arm-tune.md: gcc/config/arm/arm-cores.def gcc/config/arm/gentune.sh
83 gcc/config/arm/arm-tables.opt: gcc/config/arm/arm-arches.def gcc/config/arm/arm-cores.def gcc/config/arm/arm-fpus.def gcc/config/arm/genopt.sh
84 gcc/config/avr/avr-tables.opt: gcc/config/avr/avr-mcus.def gcc/config/avr/genopt.sh
85 gcc/config/m68k/m68k-tables.opt: gcc/config/m68k/m68k-devices.def gcc/config/m68k/m68k-isas.def gcc/config/m68k/m68k-microarchs.def gcc/config/m68k/genopt.sh
86 gcc/config/mips/mips-tables.opt: gcc/config/mips/mips-cpus.def gcc/config/mips/genopt.sh
87 gcc/config/rs6000/rs6000-tables.opt: gcc/config/rs6000/rs6000-cpus.def gcc/config/rs6000/genopt.sh
88 # And then, language-specific files
89 gcc/cp/cfns.h: gcc/cp/cfns.gperf
90 gcc/java/keyword.h: gcc/java/keyword.gperf
91 # testsuite
92 # Without this, _Pragma3.c can have a false negative.
93 gcc/testsuite/gcc.dg/cpp/_Pragma3.c: gcc/testsuite/gcc.dg/cpp/mi1c.h
94 # Similarly, without this, you will see:
95 # direct2s.c:35: warning: current file is older than direct2.c
96 gcc/testsuite/gcc.dg/cpp/direct2s.c: gcc/testsuite/gcc.dg/cpp/direct2.c
97 # lto-plugin
98 lto-plugin/configure: lto-plugin/configure.ac lto-plugin/aclocal.m4
99 lto-plugin/Makefile.in: lto-plugin/Makefile.am lto-plugin/aclocal.m4
100 # And libraries, at last
101 libbanshee/configure: libbanshee/configure.ac
102 libmudflap/configure: libmudflap/configure.ac
103 libobjc/configure: libobjc/configure.ac
104 zlib/aclocal.m4: zlib/configure.ac zlib/acinclude.m4
105 zlib/Makefile.in: zlib/Makefile.am zlib/configure.ac zlib/aclocal.m4
106 zlib/configure: zlib/configure.ac zlib/aclocal.m4
107 fastjar/aclocal.m4: fastjar/configure.ac
108 fastjar/Makefile.in: fastjar/Makefile.am fastjar/configure.ac fastjar/aclocal.m4
109 fastjar/configure: fastjar/configure.ac fastjar/aclocal.m4
110 boehm-gc/aclocal.m4: boehm-gc/configure.ac
111 boehm-gc/Makefile.in: boehm-gc/Makefile.am boehm-gc/configure.ac boehm-gc/aclocal.m4
112 boehm-gc/configure: boehm-gc/configure.ac boehm-gc/aclocal.m4
113 libada/configure: libada/configure.ac
114 libffi/aclocal.m4: libffi/configure.ac libffi/acinclude.m4
115 libffi/Makefile.in: libffi/Makefile.am libffi/configure.ac libffi/aclocal.m4
116 libffi/configure: libffi/configure.ac libffi/aclocal.m4
117 libffi/fficonfig.h.in: libffi/configure.ac libffi/aclocal.m4
118 libgfortran/aclocal.m4: libgfortran/configure.ac libgfortran/acinclude.m4
119 libgfortran/Makefile.in: libgfortran/Makefile.am libgfortran/configure.ac libgfortran/aclocal.m4
120 libgfortran/configure: libgfortran/configure.ac libgfortran/aclocal.m4
121 libjava/aclocal.m4: libjava/configure.ac
122 libjava/Makefile.in: libjava/Makefile.am libjava/configure.ac libjava/aclocal.m4
123 libjava/configure: libjava/configure.ac libjava/aclocal.m4
124 libjava/libltdl/aclocal.m4: libjava/libltdl/configure.ac libjava/libltdl/acinclude.m4
125 libjava/libltdl/Makefile.in: libjava/libltdl/Makefile.am libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
126 libjava/libltdl/configure: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
127 libjava/libltdl/config-h.in: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
128 libcpp/aclocal.m4: libcpp/configure.ac
129 libcpp/Makefile.in: libcpp/configure.ac libcpp/aclocal.m4
130 libcpp/configure: libcpp/configure.ac libcpp/aclocal.m4
131 libgomp/aclocal.m4: libgomp/configure.ac libgomp/acinclude.m4
132 libgomp/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
133 libgomp/testsuite/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
134 libgomp/configure: libgomp/configure.ac libgomp/aclocal.m4
135 libgomp/config.h.in: libgomp/configure.ac libgomp/aclocal.m4
136 # Top level
137 Makefile.in: Makefile.tpl Makefile.def
138 configure: configure.ac config/acx.m4
139 EOF
140 }
141
142
143 # This function touches generated files such that the ``end'' user does
144 # not have to rebuild them.
145 touch_files () {
146     rm -f Makefile.$$
147     echo 'all: \' > Makefile.$$
148     files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
149     echo '; @true' >> Makefile.$$
150     files_and_dependencies | sed 's, ,: ,' >> Makefile.$$
151     files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
152     echo ':' >> Makefile.$$
153     echo '      @for f in $? $@; do test -f $$f || exit 0; done; \' >> Makefile.$$
154     echo '      echo Touching $@...; \' >> Makefile.$$
155     chat '      echo Touching $@... 1>&2; \' >> Makefile.$$
156     echo '      touch $@' >> Makefile.$$
157     files_and_dependencies | sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
158
159     # We would have to explicitly shut off the "Entering... Leaving..."
160     # messages through "--no-print-directory" to handle the case when
161     # we were called from a recursive invocation (i.e. "$(MAKE)" in a
162     # Makefile, not just make).  Passing only "-s" doesn't help then,
163     # because make has helpfully added "-w" to MAKEFLAGS automatically.
164     # Unfortunately we do not require GNU make other than for building
165     # and testing, so let's just grep known text explicitly echoed by
166     # the rule.
167     while ${MAKE-make} -s -f Makefile.$$ all | grep Touching > /dev/null; do
168       sleep 1
169     done 2>&1
170     rm -f Makefile.$$
171 }
172
173
174 # Whenever we update the tree or install a patch, we may be modifying
175 # this script.  By re-execing it, we ensure that the appropriate
176 # dependencies and rules will be used.
177 touch_files_reexec () {
178     chat "Adjusting file timestamps"
179     exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
180 }
181
182 # This functions applies a patch to an existing tree.
183 apply_patch () {
184     if [ -f "$1" ]; then
185         echo "Applying patch file $1"
186         case $1 in
187         *gz)
188             gzip -d -c "$1" | patch -p1 ;;
189         *bz2)
190             bzip2 -d -c "$1" | patch -p1 ;;
191         *)
192             patch -p1 < "$1";;
193         esac
194     fi
195     touch_files_reexec
196 }
197
198 # Check whether this indeed looks like a local tree.
199 if [ ! -f gcc/version.c ]; then
200     echo "This does not seem to be a GCC tree!"
201     exit
202 fi
203
204 case "$1" in
205 --silent)
206     silent=t
207     shift
208     ;;
209 esac
210
211 case "$1" in
212 # First of all, check whether we are going to process a patch.
213 --patch)
214     if test "$#" != 2; then
215         echo "$1" expects only one argument >&2
216         exit 1
217     fi
218     apply_patch "${2}"
219     exit $?
220     ;;
221
222 --touch)
223     if test "$#" != 1; then
224         echo "$1" does not expect any argument >&2
225         exit 1
226     fi
227     touch_files
228     exit $?
229     ;;
230
231 --list)
232     if test "$#" != 1; then
233         echo "$1" does not expect any argument >&2
234         exit 1
235     fi
236     files_and_dependencies | sed 's/ /: /'
237     exit $?
238     ;;
239
240 --help)
241     sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
242 \
243
244 p
245 }' \
246         -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
247     exit $?
248     ;;
249
250 esac
251
252 # Check for known version control systems.
253 if [ -d .git ]; then
254     GCC_GIT=${GCC_GIT-${GIT-git}}
255     vcs_type="git"
256 elif [ -d .hg ]; then
257     GCC_HG=${GCC_HG-${HG-hg}}
258     vcs_type="hg"
259 elif [ -d .svn ]; then
260     GCC_SVN=${GCC_SVN-${SVN-svn}}
261     vcs_type="svn"
262 else
263     echo "This does not seem to be a GCC GIT/HG/SVN tree!"
264     exit
265 fi
266
267 # Check command-line options
268 if [ x"${1}"x = x"--nostdflags"x ]; then
269     shift
270 else
271     set -- $UPDATE_OPTIONS ${1+"$@"}
272 fi
273
274 case $vcs_type in
275     git)
276         chat "Updating GIT tree"
277
278         $GCC_GIT diff --quiet --exit-code HEAD
279         if [ $? -ne 0 ]; then
280             echo "Attempting to update a dirty git tree!" >&2
281             echo "Commit or stash your changes first and retry." >&2
282             exit 1
283         fi
284
285         $GCC_GIT pull ${silent+-q} --rebase ${1+"$@"}
286         if [ $? -ne 0 ]; then
287             (touch_files_reexec)
288             echo "git pull of full tree failed." >&2
289             exit 1
290         fi
291
292         revision=`$GCC_GIT log -n1 --pretty=%p:%t:%H`
293         branch=`$GCC_GIT name-rev --name-only HEAD || :`
294         ;;    
295
296     hg)
297         chat "Updating HG tree"
298
299         # Add -q so untracked files aren't listed.
300         if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
301             echo "Attempting to update a dirty hg tree!" >&2
302             echo "Commit or revert your changes first and retry." >&2
303             exit 1
304         fi
305
306         # Check for mq extension.  mq patches must be popped so tip has
307         # been converted from the SVN tree.
308         if [ -d .hg/patches ] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
309             # FIXME: Perhaps pop queue instead?  We could do that since we
310             # know the tree is clean.
311             echo "Attempting to update hg tree with mq patches applied!" >&2
312             echo "Pop your patches first and retry." >&2
313             exit 1
314         fi
315
316         # Update tree, but make sure to only pull the default branch.
317         # Otherwise all branches in the upstream repo are added, even if
318         # only a single one has been cloned.
319         $GCC_HG pull ${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
320         if [ $? -ne 0 ]; then
321             (touch_files_reexec)
322             echo "hg pull of full tree failed." >&2
323             exit 1
324         fi
325
326         # Update tree.  Needs to be done separately from pull so
327         # gcc_update -rREV works.
328         $GCC_HG update ${silent+-q} ${1+"$@"}
329         if [ $? -ne 0 ]; then
330             (touch_files_reexec)
331             echo "hg update of full tree failed." >&2
332             exit 1
333         fi
334
335         # Extract SVN revision corresponding to parents, as stored by
336         # hg convert.  Before hg 1.4.3, there's no template keyword
337         # corresponding to the extra: tag, so need to use hg log --debug
338         # to extract the info.
339         parents=`$GCC_HG parents --template '{rev}'`
340         revision=`$GCC_HG log --debug -r$parents | \
341             sed -ne "/^extra:.*convert_revision=svn:/ {
342                 s%^.*@%%
343                 p
344             }"`
345         branch=`$GCC_HG branch`
346         # trunk in SVN parlance shows up as default branch in hg.
347         [ x$branch = x"default" ] && branch="trunk"
348         ;;
349
350     svn)
351         chat "Updating SVN tree"
352
353         $GCC_SVN ${silent+-q}  --non-interactive update ${1+"$@"}
354         if [ $? -ne 0 ]; then
355             (touch_files_reexec)
356             echo "SVN update of full tree failed." >&2
357             exit 1
358         fi
359
360         revision=`svn info | awk '/Revision:/ { print $2 }'`
361         branch=`svn info | sed -ne "/URL:/ {
362             s,.*/trunk,trunk,
363             s,.*/branches/,,
364             s,.*/tags/,,
365             p
366         }"`
367         ;;
368 esac
369
370 rm -f LAST_UPDATED gcc/REVISION
371 {
372     date
373     echo "`TZ=UTC date` (revision $revision)"
374 } > LAST_UPDATED
375 echo "[$branch revision $revision]" > gcc/REVISION
376
377 touch_files_reexec